#!/usr/bin/python
#
# $Id: up2dateLog.py,v 1.14 2002/09/03 12:13:53 gafton Exp $

import time
import string
import config

log = None
cfg = config.initUp2dateConfig()

class Log:
    """
    attempt to log all interesting stuff, namely, anything that hits
    the network any error messages, package installs, etc
    """ # " emacs sucks
    def __init__(self):
        self.app = "up2date"

    def log_debug(self, *args):
        if cfg["debug"] > 1:
            apply(self.log_me, args, {})
            if cfg["isatty"]:
                print "D:", string.join(map(lambda a: str(a), args), " ")
                
    def log_me(self, *args):
        self.log_info = "[%s] %s" % (time.ctime(time.time()), self.app)
	s = ""
        for i in args:
            s = s + "%s" % (i,)
        self.write_log(s)

    def trace_me(self):
        self.log_info = "[%s] %s" % (time.ctime(time.time()), self.app)
        import traceback
        x = traceback.extract_stack()
        bar = string.join(traceback.format_list(x))
        self.write_log(bar)

    def write_log(self, s):
        log_name = cfg["logFile"] or "/var/log/up2date"
        log_file = open(log_name, 'a')
        msg = "%s %s\n" % (self.log_info, str(s))
        log_file.write(msg)
        log_file.flush()
        log_file.close()

def initLog():
    global log
    if log == None:
        log = Log()
            
    return log
